#!/usr/bin/perl

#$logfile='cat /var/log/exim/mainlog /var/log/exim/mainlog.1 |';
$logfile='</var/log/exim/mainlog';
$denyfile='/etc/hosts.deny';

$maxtries = 4;

open(LOG, $logfile) || die("Can't open log file.\n");

while(<LOG>)
{
	chomp;
	@line = split;

	if (($_ =~ /rejected after DATA:/) || ($_ =~ /refused: too many connections/))
	{
		$entry = 4;

		$entry = 5 if ($line[$entry] =~ /\(/);

		$address = $line[$entry];

		$address =~ s/\[//;
		$address =~ s/\]//;

		$address =~ s/\d+$//;
		$address =~ s/\d+\.$//;

		$tries{$address}++;

		if ($_ =~ /virus/)
		{
			$tries{$address} = $maxtries + 1;
		}
	}

	if ($_ =~ /no host name found for IP address/)
	{
		$address = $line[9];
		$address =~ s/\d+$//;
		$address =~ s/\d+\.$//;
		$tries{$address} = $maxtries + 1 if ($address !~ /10\.0\./);
	}

	if ($_ =~ /no IP address found for host/)
	{
		$address = $line[13];

		$address =~ s/\[//;
		$address =~ s/\]\)//;

		$address =~ s/\d+$//;
		$address =~ s/\d+\.$//;

		$tries{$address} = $maxtries + 1;
	}
}

close(LOG);

@addresses = sort(keys(%tries));

foreach $i (@addresses)
{
	if ($tries{$i} > $maxtries)
	{
		@attackers = (@attackers, $i);
	}
}

#$attackline = join(',', @attackers), "\n";

if ($#attackers >= 0 )
{
	$attackline = $attackers[0];

	for ($i = 1 ; $i <= $#attackers; $i++)
	{
		$attackline = $attackline.",";
		$attackline = $attackline."$attackers[$i]";

		if ((($i % 5) == 0) && ($i != $#attackers))
		{
			$attackline = $attackline."\\\n";
		}
	}
}

open(DENY, "<$denyfile") || die("Can't open $denyfile for reading.\n");

@denyfile = <DENY>;

close(DENY);

$isinexim = 0;

$j = 0;

for ($i = 0; $i <= $#denyfile; $i++)
{
	if ($denyfile[$i] !~ /^exim:/)
	{
		$newdenyfile[$j++] = $denyfile[$i];
	}
	else
	{
		$newdenyfile[$j++] = "exim: $attackline\n";
		$i++;

		while($denyfile[$i] =~ /^,/)
		{
			$i++;
		}
		$newdenyfile[$j++] = $denyfile[$i];
	}
}

open(DENY, ">$denyfile") || die("Can't open $denyfile for writing.\n");

print DENY @newdenyfile;
#print @newdenyfile;

close(DENY);

