#!/usr/bin/perl

$logfile='cat /var/log/exim/mainlog /var/log/exim/mainlog.1 |';
$denyfile='/etc/hosts.deny';

$maxtries = 10;

open(LOG, $logfile) || die("Can't open log file.\n");

while(<LOG>)
{
	chomp;
	next if ($_ !~ /dovecot_login/);
	next if ($_ !~ /authenticator failed/);

	@line = split;

	if  (/for \(/)
	{
		$entry = 7;
	}
	else
	{
		$entry = 8;
	}

	$address = $line[$entry];

	$address =~ s/\[//;
	$address =~ s/\]://;

	$tries{$address}++;
}

close(LOG);

@addresses = sort(keys(%tries));

foreach $i (@addresses)
{
	if ($tries{$i} > $maxtries)
	{
		@attackers = (@attackers, $i);
	}
}

$attackline = join(',', @attackers), "\n";

open(DENY, "<$denyfile") || die("Can't open $denyfile for reading.\n");

@denyfile = <DENY>;

close(DENY);

for ($i = 0; $i <= $#denyfile; $i++)
{
	next if ($denyfile[$i] !~ /^imap:/);

	$denyfile[$i] = "imap: $attackline\n";
}

open(DENY, ">$denyfile") || die("Can't open $denyfile for writing.\n");

print DENY @denyfile;

close(DENY);

