#!/usr/bin/perl

$logfile='lastb -i -s -2days |';
$denyfile='/etc/hosts.deny';

$maxtries = 10;

open(LOG, $logfile) || die("Can't open log file.\n");

while(<LOG>)
{
	chomp;

	@line = split;

	next if ($#line < 3);
	next if ($line[0] =~ 'btmp');
	next if ($line[1] !~ /^ssh:notty$/);

	$address = $line[2];

	$address =~ s/\d+$//;

	$tries{$address}++;
}

close(LOG);

@addresses = sort(keys(%tries));

foreach $i (@addresses)
{
	if ($tries{$i} > $maxtries)
	{
		@attackers = (@attackers, $i);
	}
}

#$attackline = join(',', @attackers), "\n";

if ($#attackers >= 0 )
{
	$attackline = $attackers[0];

	for ($i = 1 ; $i <= $#attackers; $i++)
	{
		$attackline = $attackline.",";
		$attackline = $attackline."$attackers[$i]";

		if (($i % 10) == 0)
		{
			$attackline = $attackline."\\\n";
		}
	}
}

open(DENY, "<$denyfile") || die("Can't open $denyfile for reading.\n");

@denyfile = <DENY>;

close(DENY);

$j = 0;

for ($i = 0; $i <= $#denyfile; $i++)
{
	if ($denyfile[$i] !~ /^sshd:/)
	{
		if ($denyfile[$i] !~ /^$/)
		{
			$newdenyfile[$j++] = $denyfile[$i];
		}
	}
	else
	{
		$newdenyfile[$j++] = "sshd: $attackline\n";
		$i++;

		while($denyfile[$i] =~ /^,/)
		{
			$i++;
		}
		$newdenyfile[$j++] = $denyfile[$i];
	}
}

open(DENY, ">$denyfile") || die("Can't open $denyfile for writing.\n");

print DENY @newdenyfile;

close(DENY);

